"""
File:  timeSearches.py
Description:  Times sequential search, two recursive binary search algorithms
              and two recursive binary search algorithms
"""
from time import clock
import sys


from linearSearch import linearSearch
from linearSearchOfSortedListA import linearSearchOfSortedListA
from linearSearchOfSortedListB import linearSearchOfSortedListB
from linearSearchOfSortedListC import linearSearchOfSortedListC
from linearSearchRecursiveA import linearSearchRecursiveA
from linearSearchRecursiveB import linearSearchRecursiveB

testSize = 1200                       # Number of items to search consisting of
sys.setrecursionlimit(2000)           # Set recursion limit for linearSearchRecursive
evenList = range(0, 2*testSize, 2)    # even numbers from 0 to 2*(testSize-1)

successful = 0
unsuccessful = 0
start = clock()
for target in xrange(2*testSize):
    position = linearSearch(target, evenList)
    if position == -1:
        unsuccessful += 1
    else:
        successful += 1
print 'linearSearch: successful =', successful
print 'linearSearch: unsuccessful =', unsuccessful
        
end = clock()
runTime = end - start
print "Time to run linearSearch on targets 0 to %d is %.6f sec." % \
      (2*(testSize - 1), runTime)

print '--------------------------------------------------------'

successful = 0
unsuccessful = 0
start = clock()
for target in xrange(2*testSize):
    position = linearSearchOfSortedListA(target, evenList)
    if position == -1:
        unsuccessful += 1
    else:
        successful += 1
print 'linearSearchOfSortedListA: successful =', successful
print 'linearSearchOfSortedListA: unsuccessful =', unsuccessful
        
end = clock()
runTime = end - start
print "Time to run linearSearchOfSortedList on targets 0 to %d is %.6f sec." % \
      (2*(testSize - 1), runTime)


print '--------------------------------------------------------'

successful = 0
unsuccessful = 0
start = clock()
for target in xrange(2*testSize):
    position = linearSearchOfSortedListB(target, evenList)
    if position == -1:
        unsuccessful += 1
    else:
        successful += 1
print 'linearSearchOfSortedListB: successful =', successful
print 'linearSearchOfSortedListB: unsuccessful =', unsuccessful
        
end = clock()
runTime = end - start
print "Time to run linearSearchOfSortedListB on targets 0 to %d is %.6f sec." % \
      (2*(testSize - 1), runTime)


print '--------------------------------------------------------'

successful = 0
unsuccessful = 0
start = clock()
for target in xrange(2*testSize):
    position = linearSearchOfSortedListC(target, evenList)
    if position == -1:
        unsuccessful += 1
    else:
        successful += 1
print 'linearSearchOfSortedListC: successful =', successful
print 'linearSearchOfSortedListC: unsuccessful =', unsuccessful
        
end = clock()
runTime = end - start
print "Time to run linearSearchOfSortedListC on targets 0 to %d is %.6f sec." % \
      (2*(testSize - 1), runTime)


print '--------------------------------------------------------'

successful = 0
unsuccessful = 0
start = clock()
for target in xrange(2*testSize):
    position = linearSearchRecursiveA(target, evenList)
    if position == -1:
        unsuccessful += 1
    else:
        successful += 1
print 'linearSearchRecursiveA: successful =', successful
print 'linearSearchRecursiveA: unsuccessful =', unsuccessful
        
end = clock()
runTime = end - start
print "Time to run linearSearchRecursive on targets 0 to %d is %.6f sec." % \
      (2*(testSize - 1), runTime)


print '--------------------------------------------------------'

successful = 0
unsuccessful = 0
start = clock()
for target in xrange(2*testSize):
    position = linearSearchRecursiveB(target, len(evenList)-1, evenList)
    if position == -1:
        unsuccessful += 1
    else:
        successful += 1
print 'linearSearchRecursiveB: successful =', successful
print 'linearSearchRecursiveB: unsuccessful =', unsuccessful
        
end = clock()
runTime = end - start
print "Time to run linearSearchOfSortedListB on targets 0 to %d is %.6f sec." % \
      (2*(testSize - 1), runTime)



